## pve-container 5.2.2

=== Makefile ===
PACKAGE=pve-container

PREFIX=${DESTDIR}/usr
BINDIR=${PREFIX}/bin
LIBDIR=${PREFIX}/lib
SBINDIR=${PREFIX}/sbin
ETCDIR=${DESTDIR}/etc
MANDIR=${PREFIX}/share/man
DOCDIR=${PREFIX}/share/doc/${PACKAGE}
LXC_SCRIPT_DIR=${PREFIX}/share/lxc
LXC_TMPL_DIR=${LXC_SCRIPT_DIR}/templates
LXC_HOOK_DIR=${LXC_SCRIPT_DIR}/hooks
LXC_CONFIG_DIR=${LXC_SCRIPT_DIR}/config
LXC_COMMON_CONFIG_DIR=${LXC_CONFIG_DIR}/common.conf.d
LXC_USERNS_CONFIG_DIR=${LXC_CONFIG_DIR}/userns.conf.d
SERVICEDIR=${DESTDIR}/lib/systemd/system
APPARMORDDIR=${ETCDIR}/apparmor.d
PODDIR=${DOCDIR}/pod
MAN1DIR=${MANDIR}/man1/
MAN5DIR=${MANDIR}/man5/
BASHCOMPLDIR=${PREFIX}/share/bash-completion/completions/
ZSHCOMPLDIR=${PREFIX}/share/zsh/vendor-completions/
export PERLDIR=${PREFIX}/share/perl5

# this require package pve-doc-generator
export NOVIEW=1
include /usr/share/pve-doc-generator/pve-doc-generator.mk

all:

pct.bash-completion:
	PVE_GENERATING_DOCS=1 perl -I. -T -e "use PVE::CLI::pct; PVE::CLI::pct->generate_bash_completions();" >$@.tmp
	mv $@.tmp $@

pct.zsh-completion:
	PVE_GENERATING_DOCS=1 perl -I. -T -e "use PVE::CLI::pct; PVE::CLI::pct->generate_zsh_completions();" >$@.tmp
	mv $@.tmp $@

.PHONY: check
check: test
	make -C test

.PHONY: install
install: pct lxc-pve.conf pct.1 pct.conf.5 pct.bash-completion pct.zsh-completion \
    pve-userns.seccomp pve-container@.service pve-container-debug@.service \
    lxc-pve-prestart-hook lxc-pve-autodev-hook lxc-pve-poststop-hook lxcnetaddbr
	PVE_GENERATING_DOCS=1 perl -I. -T -e "use PVE::CLI::pct; PVE::CLI::pct->verify_api();"
	install -d ${SBINDIR}
	install -m 0755 pct ${SBINDIR}
	install -d ${LXC_SCRIPT_DIR}
	install -m 0755 lxcnetaddbr ${LXC_SCRIPT_DIR}
	install -m 0755 pve-container-stop-wrapper ${LXC_SCRIPT_DIR}
	install -d -m0755 ${SERVICEDIR}
	install -m0644 pve-container@.service ${SERVICEDIR}/
	install -m0644 pve-container-debug@.service ${SERVICEDIR}/
	install -m0644 'system-pve\x2dcontainer.slice' ${SERVICEDIR}/
	install -d ${LXC_HOOK_DIR}
	install -m 0755 lxc-pve-prestart-hook ${LXC_HOOK_DIR}
	install -m 0755 lxc-pve-autodev-hook ${LXC_HOOK_DIR}
	install -m 0755 lxc-pve-poststop-hook ${LXC_HOOK_DIR}
	install -d ${LXC_CONFIG_DIR}
	install -m 0644 pve-userns.seccomp ${LXC_CONFIG_DIR}/pve-userns.seccomp
	install -d ${LXC_COMMON_CONFIG_DIR}
	install -m 0644 lxc-pve.conf ${LXC_COMMON_CONFIG_DIR}/01-pve.conf
	install -d ${LXC_USERNS_CONFIG_DIR}
	install -m 0644 lxc-pve-userns.conf ${LXC_USERNS_CONFIG_DIR}/01-pve.conf
	install -m 0644 -D pct.bash-completion ${BASHCOMPLDIR}/pct
	install -m 0644 -D pct.zsh-completion ${ZSHCOMPLDIR}/_pct
	make -C PVE install
	install -d ${MAN1DIR}
	install -d ${MAN5DIR}
	install -m 0644 pct.1 ${MAN1DIR}
	gzip -9 ${MAN1DIR}/pct.1
	install -m 0644 pct.conf.5 ${MAN5DIR}
	gzip -9 ${MAN5DIR}/pct.conf.5
	cd ${MAN5DIR}; ln -s pct.conf.5.gz ct.conf.5.gz
	install -D -m 0644 10-pve-ct-inotify-limits.conf ${LIBDIR}/sysctl.d/10-pve-ct-inotify-limits.conf
	install -D -m 0644 pve-container-mounthotplug ${APPARMORDDIR}/pve-container-mounthotplug

pve-userns.seccomp: /usr/share/lxc/config/common.seccomp
	cp $< $@
	echo 'keyctl errno 38' >> $@

.PHONY: test
test:
	make -C test test

.PHONY: clean
clean: 	
	make -C test clean
	make cleanup-docgen
	rm -f *.1 *.5 *.tmp *.bash-completion *.bash-completion

.PHONY: distclean
distclean: clean

=== PVE/Makefile ===
SOURCES=LXC.pm

.PHONY: install
install: ${SOURCES} 
	install -d -m 0755 ${PERLDIR}/PVE
	for i in ${SOURCES}; do install -D -m 0644 $$i ${PERLDIR}/PVE/$$i; done
	make -C API2 install
	make -C LXC install
	make -C VZDump install
	make -C CLI install

=== test/Makefile ===
RUN_USERNS := lxc-usernsexec -m "u:0:`id -u`:1" -m "g:0:`id -g`:1" --

all: test

test: test_setup test_snapshot test_bindmount test_idmap

test_setup: run_setup_tests.pl
	if test -e /run/lock/sbuild; then \
		echo skipping userns tests in sbuild environment ; \
	else \
		$(RUN_USERNS) ./run_setup_tests.pl ; \
	fi

test_snapshot: run_snapshot_tests.pl
	./run_snapshot_tests.pl

test_bindmount: bindmount_test.pl
	if test -e /run/lock/sbuild; then \
		echo skipping userns tests in sbuild environment ; \
	else \
		$(RUN_USERNS) ./bindmount_test.pl ; \
	fi

test_idmap: run_idmap_tests.pl
	./run_idmap_tests.pl

clean:
	rm -rf tmprootfs

=== PVE/API2/Makefile ===
SOURCES=LXC.pm

.PHONY: install
install:
	install -d -m 0755 ${PERLDIR}/PVE/API2
	for i in ${SOURCES}; do install -D -m 0644 $$i ${PERLDIR}/PVE/API2/$$i; done
	make -C LXC install

=== PVE/CLI/Makefile ===
SOURCES=pct.pm

.PHONY: install
install: ${SOURCES} 
	install -d -m 0755 ${PERLDIR}/PVE/CLI
	for i in ${SOURCES}; do install -D -m 0644 $$i ${PERLDIR}/PVE/CLI/$$i; done

=== PVE/LXC/Makefile ===
SOURCES= \
	CGroup.pm \
	Command.pm \
	Config.pm \
	Create.pm \
	Migrate.pm \
	Monitor.pm \
	Setup.pm \
	Tools.pm

.PHONY: install
install: ${SOURCES} 
	install -d -m 0755 ${PERLDIR}/PVE/LXC
	for i in ${SOURCES}; do install -D -m 0644 $$i ${PERLDIR}/PVE/LXC/$$i; done
	make -C Setup install

=== PVE/VZDump/Makefile ===

.PHONY: install
install:
	install -D -m 0644 LXC.pm ${PERLDIR}/PVE/VZDump/LXC.pm
	install -D -m 0644 ConvertOVZ.pm ${PERLDIR}/PVE/VZDump/ConvertOVZ.pm

=== PVE/API2/LXC/Makefile ===
SOURCES=Config.pm Status.pm Snapshot.pm

.PHONY: install
install:
	install -d -m 0755 ${PERLDIR}/PVE/API2/LXC
	for i in ${SOURCES}; do install -D -m 0644 $$i ${PERLDIR}/PVE/API2/LXC/$$i; done

=== PVE/LXC/Setup/Makefile ===
SOURCES=\
    Plugin.pm		\
    Base.pm		\
    Alpine.pm		\
    ArchLinux.pm	\
    CentOS.pm		\
    Debian.pm		\
    Devuan.pm		\
    Fedora.pm		\
    Gentoo.pm		\
    SUSE.pm		\
    Ubuntu.pm		\
    NixOS.pm		\
    OpenEuler.pm	\
    Unmanaged.pm	\

.PHONY: install
install:
	install -d -m 0755 ${PERLDIR}/PVE/LXC/Setup
	for i in ${SOURCES}; do install -D -m 0644 $$i ${PERLDIR}/PVE/LXC/Setup/$$i; done

=== debian/changelog ===
pve-container (5.2.2) bookworm; urgency=medium

  * network config: avoid committing invalid config on hotplug failure, rather
    try rolling back to previous config

  * setup: add support Ubuntu 24.10 and future 25.04

  * setup centos & derivatives: hostname: only read sysconfig network if
    exist. This fixes the support for Fedora 41 images.

 -- Proxmox Support Team <support@proxmox.com>  Tue, 19 Nov 2024 14:02:54 +0100

pve-container (5.2.1) bookworm; urgency=medium

  * api status: add some missing descriptions in return schema

  * fix #5761: add the "discard" mount option

  * fix typos on user-visible strings

  * fix #5762: lxc: setup: support `opensuse-slowroll` as OpenSUSE
    flavor

  * fix #5742: lxc: setup: centos template keep static ipv6 assignment

  * fix #5720: add setup support for openEuler

  * CentOS: disable some systemd units for sysfs debug mounts that
    cannot work in containers

 -- Proxmox Support Team <support@proxmox.com>  Fri, 08 Nov 2024 16:00:46 +0100

pve-container (5.2.0) bookworm; urgency=medium

  * fix #5674: add missing 'proxyto' for LXC interfaces API

  * fedora setup: drop checking for to new version, allowing 41 and newer
    uncoditionally.

  * backup: warn that tar does not honor exclusion pattern with a trailing
    slash

  * add 'deny-write' option for device passthrough to make said device
    read-only

  * api: improve CLI auto-completion of the storage parameter for the 'create'
    and 'move-volume' commands such that it includes a storage only if it has
    the 'rootdir' container content type enabled.

  * add auto-completion of the storage parameter for the 'clone' command

 -- Proxmox Support Team <support@proxmox.com>  Tue, 10 Sep 2024 16:47:03 +0200

pve-container (5.1.12) bookworm; urgency=medium

  * backup: log errors from rsync

  * d/control: relax versioned dependency for backup client again

 -- Proxmox Support Team <support@proxmox.com>  Tue, 18 Jun 2024 09:16:15 +0200

pve-container (5.1.11) bookworm; urgency=medium

  * remote migration: enable schema validation

  * vzdump: conditionally set PBS change detection mode option

 -- Proxmox Support Team <support@proxmox.com>  Mon, 10 Jun 2024 13:58:17 +0200

pve-container (5.1.10) bookworm; urgency=medium

  * fix #5414: use proper percentages in `pct df`

  * setup: support Ubuntu 24.04 Noble

  * setup: unlink default netplan configuration even with Ubuntu >= 23.04

 -- Proxmox Support Team <support@proxmox.com>  Thu, 02 May 2024 14:37:10 +0200

pve-container (5.0.11) bookworm; urgency=medium

  * api: fix regression with locking and start-after-create

 -- Proxmox Support Team <support@proxmox.com>  Wed, 24 Apr 2024 14:28:00 +0200

pve-container (5.0.10) bookworm; urgency=medium

  * api: status: move config locking from API handler into the task worker to
    avoid potentially blocking the API daemon

  * fix #5160: fix move-mount regression for mount point hotplug

  * api: container index: fix return type of vmid to ensure its an integer

  * pct: fsck: also clean-up (unmap) any mounted volume when the fsck command
    failed

  * ensure that device passthrough changes do not get written to the config
    even though they fail basic validation like if the device exists

  * fix #4474: api: add overrule-shutdown parameter to stop endpoint

  * fix #4846: avoid setting the deprecated noacl mount option on ext4

  * firewall: add handling for new nftables based firewall implementation,
  which currently is a opt-in drop-in replacement for the older iptables-
  based one.

 -- Proxmox Support Team <support@proxmox.com>  Fri, 19 Apr 2024 20:33:01 +0200

pve-container (5.0.9) bookworm; urgency=medium

  * config: schema: remove duplicate attribute assignment for mpX

  * fix #5194: pct: delete environment variables set by pve

  * pct: drop completion helper for target storage on remote-migration

  * pct: add keep-env option to the 'enter' and 'exec' command

 -- Proxmox Support Team <support@proxmox.com>  Fri, 15 Mar 2024 10:24:22 +0100

pve-container (5.0.8) bookworm; urgency=medium

  * sdn: pass vmid and hostname to allow requesting a new mapping

 -- Proxmox Support Team <support@proxmox.com>  Wed, 22 Nov 2023 14:11:52 +0100

pve-container (5.0.7) bookworm; urgency=medium

  * allow passing raw device nodes through to containers

  * recommend libpve-network-perl for SDN support

  * initial support for dhcp ip allocation in dhcp-enabled SDN zones

  - Proxmox Support Team <support@proxmox.com>  Tue, 21 Nov 2023 15:37:14 +0100

 -- Proxmox Support Team <support@proxmox.com>  Tue, 21 Nov 2023 15:45:04 +0100

pve-container (5.0.6) bookworm; urgency=medium

  * api: network: add endpoint to get interfaces details like configured IPs

  * setup: fix architecture detection for NixOS containers

  * setup base: disable sysfs debug mounts via systemd presets, used by Debian
    12+, Fedora 37+, CentOS 8+, ArchLinux and Ubuntu 23.04+.

  * setup: handle getty services also via systemd-preset to avoid potential
    glitches that happen only for the first boot. For example, Fedora 39 had
    no console available during the first boot.

 -- Proxmox Support Team <support@proxmox.com>  Sun, 19 Nov 2023 19:29:01 +0100

pve-container (5.0.5) bookworm; urgency=medium

  * fix #4765: pct: do not report cpu usage

  * config permission check: also check access for currently configured
    bridge

  * fix #3460: restore: honor 'ignore-unpack-errors' flag for Proxmox Backup
    Server backup source

  * fix #3069: vzdump: add 'pbs-entries-max' parameter

 -- Proxmox Support Team <support@proxmox.com>  Mon, 18 Sep 2023 16:51:24 +0200

pve-container (5.0.4) bookworm; urgency=medium

  * setup: fedora: fix regression with wrong systemd-networkd preset for
    Fedora 37 and newer

 -- Proxmox Support Team <support@proxmox.com>  Sat, 24 Jun 2023 15:08:37 +0200

pve-container (5.0.3) bookworm; urgency=medium

  * migration: only migrate volumes used by the guest not also those


=== debian/control ===
Source: pve-container
Section: perl
Priority: extra
Maintainer: Proxmox Support Team <support@proxmox.com>
Build-Depends: debhelper-compat (= 13),
               dh-apparmor,
               libpve-access-control (>= 8.0.0~),
               libpve-cluster-perl,
               libpve-common-perl (>= 8.1.0),
               libpve-guest-common-perl (>= 5.1.0),
               libpve-storage-perl,
               libtest-mockmodule-perl,
               lxc-pve (>= 4.0.9-2) | lxc (>= 4.0.9),
               pve-cluster (>= 4.0-8),
               pve-doc-generator (>= 5.3-3),
               pve-firewall,
Standards-Version: 4.6.2

Package: pve-container
Section: perl
Priority: optional
Architecture: all
Depends: binutils,
         file,
         libpve-access-control (>= 8.0.0~),
         libpve-cluster-perl,
         libpve-common-perl (>= 8.1.0),
         libpve-guest-common-perl (>= 5.1.3),
         libpve-storage-perl (>= 7.2-10),
         lxc-pve,
         pve-cluster (>= 4.0-8),
         pve-ha-manager (>= 3.0-9),
         pve-lxc-syscalld,
         proxmox-backup-client (>= 3.2.3-1),
         xz-utils,
         ${misc:Depends},
         ${perl:Depends},
Recommends: libpve-network-perl (>= 0.8.3),
Description: Proxmox VE Container management tool
 Tool to manage Linux Containers on Proxmox VE.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_installsystemd:
	dh_installsystemd -ppve-container --no-start --no-enable --no-restart-after-upgrade -r 'system-pve\x2dcontainer.slice'

override_dh_install:
	dh_apparmor -p pve-container --profile-name=pve-container-mounthotplug
